/*
 * xHarbour compatible extended Inkey() key codes
 *
 * Copyright 2013 Przemyslaw Czerpak <druzus / at / priv.onet.pl>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2, or (at your option)
 * any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this software; see the file COPYING.  If not, write to
 * the Free Software Foundation, Inc., 59 Temple Place, Suite 330,
 * Boston, MA 02111-1307 USA (or visit the web site https://www.gnu.org/).
 *
 * As a special exception, the Harbour Project gives permission for
 * additional uses of the text contained in its release of Harbour.
 *
 * The exception is that, if you link the Harbour libraries with other
 * files to produce an executable, this does not by itself cause the
 * resulting executable to be covered by the GNU General Public License.
 * Your use of that executable is in no way restricted on account of
 * linking the Harbour library code into it.
 *
 * This exception does not however invalidate any other reasons why
 * the executable file might be covered by the GNU General Public License.
 *
 * This exception applies only to the code released by the Harbour
 * Project under the name Harbour.  If you copy code from other
 * Harbour Project or Free Software Foundation releases into a copy of
 * Harbour, as the General Public License permits, the exception does
 * not apply to the code that you add in this way.  To avoid misleading
 * anyone as to the status of such modified files, you must delete
 * this exception notice from them.
 *
 * If you write modifications of your own for Harbour, it is your choice
 * whether to permit this exception to apply to your modifications.
 * If you do not wish that, delete this exception notice.
 *
 */

#ifndef XHB_INKEY_CH_
#define XHB_INKEY_CH_

/* New control keys that do not overlap with other codes */

#define XHB_K_CTRL_A            513   /* Ctrl-A      */
#define XHB_K_CTRL_B            514   /* Ctrl-B      */
#define XHB_K_CTRL_C            515   /* Ctrl-C      */
#define XHB_K_CTRL_D            516   /* Ctrl-D      */
#define XHB_K_CTRL_E            517   /* Ctrl-E      */
#define XHB_K_CTRL_F            518   /* Ctrl-F      */
#define XHB_K_CTRL_G            519   /* Ctrl-G      */
#define XHB_K_CTRL_H            520   /* Ctrl-H      */
#define XHB_K_CTRL_I            521   /* Ctrl-I      */
#define XHB_K_CTRL_J            522   /* Ctrl-J      */
#define XHB_K_CTRL_K            523   /* Ctrl-K      */
#define XHB_K_CTRL_L            524   /* Ctrl-L      */
#define XHB_K_CTRL_M            525   /* Ctrl-M      */
#define XHB_K_CTRL_N            526   /* Ctrl-N      */
#define XHB_K_CTRL_O            527   /* Ctrl-O      */
#define XHB_K_CTRL_P            528   /* Ctrl-P      */
#define XHB_K_CTRL_Q            529   /* Ctrl-Q      */
#define XHB_K_CTRL_R            530   /* Ctrl-R      */
#define XHB_K_CTRL_S            531   /* Ctrl-S      */
#define XHB_K_CTRL_T            532   /* Ctrl-T      */
#define XHB_K_CTRL_U            533   /* Ctrl-U      */
#define XHB_K_CTRL_V            534   /* Ctrl-V      */
#define XHB_K_CTRL_W            535   /* Ctrl-W      */
#define XHB_K_CTRL_X            536   /* Ctrl-X      */
#define XHB_K_CTRL_Y            537   /* Ctrl-Y      */
#define XHB_K_CTRL_Z            538   /* Ctrl-Z      */

/* extended shift key codes, none in Clipper */

#define XHB_K_SH_LEFT           424   /* Shift-Left  */
#define XHB_K_SH_UP             425   /* Shift-Up    */
#define XHB_K_SH_RIGHT          426   /* Shift-Right */
#define XHB_K_SH_DOWN           427   /* Shift-Down  */

#define XHB_K_SH_INS            428   /* Shift-Ins   */
#define XHB_K_SH_DEL            429   /* Shift-Del   */
#define XHB_K_SH_HOME           430   /* Shift-Home  */
#define XHB_K_SH_END            431   /* Shift-End   */
#define XHB_K_SH_PGUP           432   /* Shift-PgUp  */
#define XHB_K_SH_PGDN           433   /* Shift-PgDn  */

#define XHB_K_SH_RETURN         434   /* Shift-Enter */
#define XHB_K_SH_ENTER          434   /* Shift-Enter */

#endif /* XHB_INKEY_CH_ */
